static char rcsid [] = "$Id: rtoracle-ts.cc,v 1.1 2001/08/07 22:10:21 suman Exp suman $";

/*
 * $Log: rtoracle-ts.cc,v $
 * Revision 1.1  2001/08/07 22:10:21  suman
 * Initial revision
 *
 */

/*
 * File: rtoracle-ts.cc
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <assert.h>
#include <node.h>
#include <rtoracle-ts.h>

#include <tsrt.h>

extern "C" Graph * restore_graph (char *);
//extern "C" Graph * restore_graph ();

extern Graph * g;

extern Node ** ptr_global_node_array;

void RoutingTableOracleTs::InitNodeRT (int num_nodes) {

  return;
}

int RoutingTableOracleTs::get_next_hop_id (int dst) {

  return get_next_hop(n->id,dst);
}

double RoutingTableOracleTs::get_path_cost (int dst) {

  return get_cost(n->id,dst);
}

/* Creates the routing table for all nodes */
void createTSOracleRT (char *gb_filename, int num_nodes) {

  g = restore_graph(gb_filename);
  if (g == NULL) {
    printf("[Routing] %s doesn't contain SGB graph\n",gb_filename);
    exit(1);
  }

  assert (g->n == num_nodes);

  for (int i = 0; i < num_nodes; i++) {

    assert (ptr_global_node_array[i]->id == i);
    ptr_global_node_array[i]->rt = new RoutingTableOracleTs(ptr_global_node_array[i]);
  }

  printf ("[Routing] starting to create domain routes\n");
  create_domain_routes();
  printf ("[Routing] finished creating domain routes\n");
  
//slee
//----- made some changes
  for (int i = 0; i < g->n; i++) {
    Node *n1 = ptr_global_node_array[i];
	if ( g->vertices[i].name[0] == 'T' )
		n1->is_transit = 1;
	else
		n1->is_transit = 0;

	//if ( n1->is_transit) fprintf(stderr, "transit node %d: %d\n", i, n1->is_transit);

    for (Arc * a = g->vertices[i].arcs; a; a = a->next) {
      Node *n2 = ptr_global_node_array[a->tip - g->vertices];
      n1->add_neighbor(n2,a->len);
    }
  }
//slee
  /*
   * slee
  fprintf(stderr, "node 6363: %s\n", g->vertices[6363].name );
  */
  return;
}     

