BEGIN {
  found = 0; 

  if (coopcount == "") {
    printf("Err: coopcount not set\n");
    exit(0);
  }

  srand(2000);
  seed = int(10000*rand());
   
  bsestart = 10.00;
  coopstart_base = 11.00;
    
  source_agent = 1; 

  data_start_time = 500.00; 
  dest_start_gap = 200.00; 
  data_gap = 0.0625; 
  data_burstsize = 5200;

  
  attached;

  tsgraph = ARGV[1];
  niceout = sprintf("%d-slee",coopcount);

  sub(/alt/,"gb",tsgraph);

  nodestart = 1.0;
  numnodes;
  numedges;
  foundnodes = 0; 
  foundedges = 0; 
  startnodes = 0; 
  startagents = 0; 
  startedges = 0; 

  foundvertices = 0;

  simstop = 851.00001; 
  
  printf ("set seed %d;\n",seed) > niceout;
}

{
  if ($1 == "GRAPH")
    foundnodes = 1;  

  if (($1 != "GRAPH") && (foundnodes == 1)) {
    foundnodes = 0; 
    numnodes = $1;
    numedges = $2; 
    printf ("nodecount %d;\n\n", numnodes) > niceout;
    if (tsgraph != "")
      printf("routing oracle ts '%s';\n\n",tsgraph) > niceout;
    else
      printf("routing oracle;\n\n") > niceout;
  }


  if (tsgraph == "") {
    if ($1 == "EDGES") {
      foundedges = 1; 
      edgecount = 0; 
    }

    if (($1 != "EDGES") && (foundedges == 1) && (edgecount < numedges/2)) {
      printf("edge %d %d %d;\n",$1,$2,$3) > niceout;
      edgecount++; 
      if (edgecount == numedges/2) {
        foundedges = 0; 
        printf ("\n") > niceout;
      }
    }

  }

  	pattern = "T:";
	if ( $1 == "VERTICES" ) {
		foundvertices = 1;
		nodecount = 0;
	}
	if ( ($1 != "VERTICES" ) && (foundvertices == 1 ) && (nodecount < numnodes ) ) {
		if ( match( $2 , pattern ) != 0 )
			attached[nodecount] = 2;
;#printf("%s %d pppppp \n", $2, match($2, pattern) );
		nodecount++;

		if ( nodecount == numnodes )
			foundvertices = 0;
	}
    
}


END {

  bsenode = int(rand()*numnodes); 
    while (bsenode in attached) {
    	bsenode = int(rand()*numnodes);
	}
  attached[bsenode] = "1";
  printf("attach agent 0 node %d bse;\n",bsenode) > niceout; 
  
  for (i = 1; i <= coopcount; i++) {
    target_node = int(rand()*numnodes);
    while (target_node in attached) {
    	target_node = int(rand()*numnodes);
	}

    attached[target_node] = 1;
    printf("attach agent %d node %d coop;\n",i,target_node) > niceout; 
	if ( i == 1 )
		node_for_1 = target_node;
  }         

  ;#falseflag = 0;

  if ( 2 * coopcount < numnodes ) {
	  for ( i = 1 ; i <= coopcount ; i++ ) {
		target_node = int(rand()*numnodes);
		while (target_node in attached)
		  target_node = int(rand()*numnodes);
		attached[target_node] = 1;
		printf("attach agent %d node %d coop;\n",i + coopcount,target_node) > niceout; 
	  }         
  }
  else {
	  cnt = 0;
	  for ( i = 0; i < numnodes; i++ ) {
		  ;#printf("# kkkk %d %d %d\n", i, attached[i], numnodes ) > niceout;
		if ( attached[i] != 1 ) {
			cnt++;
			;#printf("#===========\n\n") > niceout ;
			printf("attach agent %d node %d coop;\n", cnt + coopcount , i) > niceout; 
			attached[i] = 1;
		}
	  }
  }

  printf("\n") > niceout; 
  for (i = 0; i < numnodes; i++) {
    printf("at %f node %d start;\n",nodestart,i) > niceout; 
  }

  printf ("\n") > niceout; 
  printf("at %f agent 0 start;\n", bsestart) > niceout; 

  max_start_time = 0;

  for (i = 1; i <= coopcount; i++) {
    this_start_time = coopstart_base + rand() * dest_start_gap;
    if (i == source_agent)
      this_start_time = coopstart_base;
    printf("at %f agent %d start;\n",this_start_time,i) > niceout; 
	if ( max_start_time < this_start_time )
		max_start_time = this_start_time;
  }
  printf("\n") > niceout; 

  printf("##max_start_time = %f\n\n", max_start_time );

  printf("set ccrct 10.1;\n") > niceout ;
  printf("set ccrmt 5.0;\n") > niceout ;
  printf("set seed 876;\n") > niceout ;
  printf("set cjqt 2.0;\n") > niceout ;
  printf("set chlprt 2.0;\n") > niceout ;
  printf("set chlpit 20.3;\n\n\n") > niceout ;
  printf("set prs 0.00;   #random prob\n") > niceout ;
  printf("set cbms 0;   #bitmap size\n") > niceout ;
  printf("set pad 0.10;   #agent down prob\n") > niceout ;
  printf("set cpi 4;\n") > niceout ;

  printf("set slack 1;\n") > niceout ;

  printf("set correl 0;\n") > niceout ;

  printf("set rseed 4321;\n\n\n") > niceout ;


  printf("at %f agent %d source constant burstsize %d gap %0.7f;\n\n", data_start_time, 0,data_burstsize,data_gap) > niceout;
  printf("#at %f simulator print;\n",simstop - 0.001) > niceout; 
  printf("at %f node %d stop;\n\n",simstop, bsenode ) > niceout; 
  printf("at %f simulator stop;\n\n",simstop + 0.00001) > niceout; 

#  system(sprintf("awk -f nicetoendsys.awk %s",niceout));
}



