BEGIN {
  found = 0; 
  rpnode; 
  mcprob = 0.2; 
  rpstart = 10.00;

# base = 11.0, len = 2.0, gap = 10.0 anf count = 50 => 50 agents join each time
# within a period of 2 secs. This repeats every 10 secs.
# This starts from time 11 secs.
  mcstart_base = 11.00;
  mcstart_burst_len = 2.0;
  mcstart_burst_gap = 10.0;
  mcstart_burst_count = 50;

  source_time = 250.0;

  tsgraph = "../../data/tops/ts10k/10k-0.gb";

  nodestart = 1.00;
  numnodes;
  numedges;
  foundnodes = 0; 
  foundedges = 0; 
  startnodes = 0; 
  startagents = 0; 
  startedges = 0; 
  startevents = 0;
  simstop = 300; 
  if (mcprob == "") {
    printf("no probability specified for coop-agent\n"); 
    exit(0); 
  }
}

{
  if ($1 == "GRAPH")
    foundnodes = 1;  

  if (($1 != "GRAPH") && (foundnodes == 1)) {
    foundnodes = 0; 
    numnodes = $1;
    numedges = $2; 
    printf("nodecount %d;\n\n",$1); 
    if (tsgraph != "")
      printf ("routing oracle ts '%s';\n", tsgraph);
    else
      printf ("routing oracle;\n");
  }


  if (tsgraph == "") {
    if ($1 == "EDGES") {
      foundedges = 1; 
      edgecount = 0; 
    }

    if (($1 != "EDGES") && (foundedges == 1) && (edgecount < numedges/2)) {
      printf("edge %d %d %0.1f;\n",$1, $2, $3); 
      edgecount++; 
      if (edgecount == numedges/2) {
        foundedges = 0; 
        printf("\n");
      }
    }
  }
    
}


END {
  srand(); 
  rpnode = int(rand()*numnodes); 
  printf("attach agent %d node %d bse;\n",0,rpnode); 
  agentcount = 1; 
  for (i = 0; i < numnodes; i++) {
    if ((rand() <= mcprob) && (i != rpnode)) {
      printf("attach agent %d node %d coop;\n",agentcount,i); 
      agentcount++; 
    }
  }
  printf("\n"); 
  for (i = 0; i < numnodes; i++) {
    printf("at %0.2f node %d start;\n",nodestart,i); 
  }
  printf("\n"); 
  printf("at %0.2f agent 0 start;\n",rpstart); 
  for (i = 1; i < agentcount; i++) {
    setindex = int(i / mcstart_burst_count);
    this_start_time = mcstart_base + setindex * mcstart_burst_gap + rand() * mcstart_burst_len;
    printf("at %0.2f agent %d start;\n",this_start_time,i); 
  }
  printf("\n"); 

  printf ("at %0.2f agent %d source constant burstsize 1 gap 10.0;\n", source_time, (agentcount -1));
  printf("at %0.2f simulator print;\n",simstop-1); 
  printf("at %0.2f simulator stop;\n",simstop); 
}
