/*
 * File: rtoracle-ts.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */

#ifndef _RTORACLE_TS_H_
#define _RTORACLE_TS_H_

#include <rt.h>

/* For node i, the next hop is next_hop_id[i] */
/* If valid is false, then there is no known next hop path */

class RoutingTableOracleTs : public RoutingTable {

public:
/*
  int num_nodes;
  bool *valid;
  int *next_hop_id;
  double *cost;
*/

public:
  RoutingTableOracleTs (Node *N) : RoutingTable (ROUTE_ORACLE_TS,N) {};

  int get_next_hop_id (int dst);
  double get_path_cost (int dst);

public:
  void InitNodeRT (int num_nodes);

};

void createTSOracleRT (char * gb_filename, int num_nodes);

#endif _RTORACLE_H_
