/*
 * File: timer.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */

#ifndef _TIMER_H_
#define _TIMER_H_

enum TimerType {
  NODE_TIMER_PKT_SEND,
  NODE_TIMER_POLL
};

class Timer {

   private :
     static int timer_id_gen;
     int id;
     bool is_set;

   public :
     void *pos; // The pos returned on insertion into the scheduler

     Timer(void);
     virtual ~Timer (void);
     inline int get_id() {return id;};
     inline void * get_pos() {return pos;};
     void Handler (void); /* The generic handler */
     virtual void EventHandler (void) = 0; /* Timer specific handler */

     void SetTimer (double rel_time);
     void CancelTimer (void);
};
#endif _TIMER_H_

