/*
 * File: parser-event.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */

#ifndef _PARSER_EVENT_H_
#define _PARSER_EVENT_H_

#include <linked-list.h>
#include <node.h>
#include <agent.h>

#define MAX_NAME_SIZE   256

struct Edge {
  int node1;
  int node2;
  double wt;

  Edge (int n1, int n2, double w) { node1 = n1; node2 = n2; wt = w; }
};


enum AtEventType {
  STOP_SIMULATION,
  START_NODE,
  STOP_NODE,
  START_AGENT,
  STOP_AGENT,
  SOURCE_AGENT,
  PRINT_SIMULATION_STATUS
};

struct AtEvent {

  double at;
  AtEventType t;
  int node;
  int agent;
  SourceDistributionType sdt;
  int source_burst;
  double source_gap;

  /*  AtEvent (double at_time, AtEventType tp) {
    at = at_time;
    t = tp;
    } */
};

struct Attachment {

  int agent;
  int node;
  int atp;

  Attachment (int A, int N, AgentType Atp) { agent = A; node = N; atp = Atp; }
};

struct ParserReturnInfo {

  int num_nodes;
  int num_agents;
  LinkedList<Edge *,int> *edge_list;
  LinkedList<Attachment *, int> *attach_list;
  LinkedList<AtEvent *, double> *ev_list;
};

#endif _PARSER_EVENT_H_
