/**************************************************
 *
  File: common.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  NICE implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _COMMON_H_
#define _COMMON_H_

#include <agent.h>
#include "app-packet.h"

class LayerAgentInfo;
class LayerInfo;

void init_join_query_packet (AppPacket *ap, int lid, double time, bool attach);
void put_info_into_join_forward_packet (AgentInfo src_ag, int qlid, AgentInfo orig_dst, double send_time, bool attach, AppPacket *ap);
void put_cluster_remove_info_into_packet (LayerInfo *layer, AppPacket *ap, bool root_xfer, LayerInfo * higher, int self_aid, int self_nid);

void put_layer_cluster_info_into_packet (LayerInfo * layer, AppPacket *ap);
void put_cluster_refresh_packet_dist_info_into_layer_agent (AppPacket *ap, LayerAgentInfo *la_ag);
void put_packet_cluster_info_into_layer (AppPacket *ap, LayerInfo *layer);

void put_array_info_in_cluster_tree (TreeInfo * arr, int size, LayerInfo *l);

int create_cluster_tree_info_in_array (LayerInfo *l, TreeInfo *arr, AgentInfo * ignore_ag, bool root_null_possible);

void put_info_into_tree_array_struct (TreeInfo& t, int aid, int nid, int num_children, double dist);

/*
void create_tree_info_in_array (SimpleTree<AgentInfo *> & tree, TreeInfo * arr); 
int add_tree_info_to_array (SimpleTree<AgentInfo *> & tree, void * pos, TreeInfo * arr, int index);
*/

void put_hl_cluster_info_into_packet (LayerInfo *l, AppPacket *ap, AgentInfo * ignore_ag);
void put_cluster_refresh_hl_info_into_layer_agent (AppPacket *ap, LayerInfo *l, int self_aid, int self_nid);

void * safe_malloc (int size);

#endif _COMMON_H_
