/**************************************************
 *
  File: app-packet.cc
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  UNI implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _APP_PACKET_H_
#define _APP_PACKET_H_

#include <packet.h>

#define MAX_RET_COUNT 600

enum AppPacketSubType {

  JOIN,
  SOURCE,
  SOURCE_UPDATE,

  PACKET_DATA,

  PACKET_UNDEFINED
};

struct PacketAgentInfo {

  int agent_id;
  int node_id;
};

struct source_update_pkt {

  int count;
  PacketAgentInfo arr[MAX_RET_COUNT];
};

struct data_pkt {

  int seq_no;
};

class AppPacket : public Packet {

public :

  AppPacketSubType st;
  union {

    source_update_pkt sourceupdate_p;
    data_pkt data_p;
  } u;

  AppPacket (AppPacketSubType St) : Packet() { 
    t = PACKET_APP; 
    st = St; 
  };

};

#endif _APP_PACKET_H_

